#include "colors.inc"
#include "textures.inc"
#include "woods.inc"

// parametry plotu

#declare DlugSegmPl = 5
#declare WysokPl = 4
#declare OdstepBePl = 1
#declare WysokBePl = 1
#declare IleBePl = 3

///////////

// kolorki

#declare StaryRGB = <0.65,0.65,0.55>
#declare Stary2RGB = <0.55,0.55,0.45>
#declare StickRGB = <0.46,0.57,0.42>
#declare WzmocRGB = <0.53,0.65,0.50>
#declare WchlanRGB = <0.93,0.93,0> #declare AsymRGB = <0.14,1,0.14>

// alternatywny zestaw
/*
#declare StaryRGB = <0.3,0.3,0.2>
#declare Stary2RGB = <0.2,0.2,0.2>
#declare StickRGB = <0.5,0.5,0.5>
#declare WzmocRGB = <0.6,0.6,0.6>
#declare WchlanRGB = <1.0,1.0,0.2>
#declare AsymRGB = <0.2,0.9,0.1>
*/

#declare Mie1RGB=<1,0.1,0.1>
#declare Mie2RGB=<1,0,0>
#declare Mie3RGB=<0.3,0,0>

// jak kiedys przyjdzie ci do glowy zmieniac ambient
// to tylko tu
#declare GlobalAmbient=3.0

global_settings
 {
 max_trace_level 50
 adc_bailout 0.1
 ambient_light GlobalAmbient
 assumed_gamma 2.2
 }

//fog 
//{  distance 60   colour rgb<0.6, 0.8, 0.75> } //dist 16 ok

#declare SimpleStickTexture = texture
	{ pigment { color Red }
	  finish { phong 1 }
   }

#declare WallTexture = texture { pigment {granite} }

#declare Border = 20.0

#declare Ground0Texture = texture
	{ 
	pigment
//   {color rgb <1,0.9,0.6>}
	 {
	 granite
		color_map
			{
			[ 0.0 rgb <0.95, 0.90, 0.60> ]
			[ 0.7 rgb <0.76, 0.70, 0.40> ]
			[ 1.0 rgb <0.76, 0.70, 0.40> ]
			}
	 scale 3
	 }
    normal {bumps 0.2 scale 0.02} 
	}

#declare UnderwaterTexture=texture
{
	pigment
    {
	 granite
	color_map
      { [ 0 color Gray60 ]
		  [ 1 color White ] }
	scale 2
    }
}

#declare HighTexture=texture
{
	pigment
    {
	 crackle
	color_map
      { [ 0 color Gray40 ]
		  [ 0.1 color Gray80 ]
		  [ 1 color White ] }
    }
}

#declare WaterTexture = texture
{
 pigment { red 0.7 green 0.7 blue 1.0 filter 0.9 }
 finish { refraction 1.0 ior 1.2 reflection 0.3 caustics 0.2 }
 normal { bumps 0.5 scale 2 }
}

#declare SzybkoscFal = <0,0,0.2>

#declare Chlup = merge
{
sphere { <0,0,0>,1 }
sphere { <1,0.5,0>,1 }
sphere { <0.5,-1,0.5>,1 }
sphere { <-0.5,0.5,-1>,1 }
scale 0.3
texture { WaterTexture }
}

light_source { <1000, -2000, 3000> color 
// White
 rgb <1.5,1.5,1.5>
 }

// An area light (creates soft shadows)
// WARNING: This special light can significantly slow down rendering times!
/*
light_source
{
  0*x // light's position (translated below)
  color rgb 0.7  // light's color
  // <widthVector> <heightVector> nLightsWide mLightsHigh
  area_light
  <8, 0, 0> <0, 0, 8> // lights spread out across this distance (x * z)
  4, 4                // total number of lights in grid (4x*4z = 16 lights)
  adaptive 0          // 0,1,2,3... 
  jitter              // adds random softening of light
  translate <10, 10, -40>   // <x y z> position of light
}
*/

sky_sphere {

    pigment {
        gradient y
        pigment_map {
            [0.01 rgb <0.9, 0.92, 0.95> ] // horizon
            [0.25

    wrinkles
    turbulence 0.65
    octaves 6
    omega 0.7
    lambda 2
    color_map {
        [0.0 color rgb <0.93,0.93,0.93>]
        [0.1 color rgb <0.88,0.88,0.88>]
        [0.5 color rgb <0.4, 0.4, 0.8>]
        [1.001 color rgb <0.31, 0.36, 0.93>]
    }
    scale <1.5, 0.25, 1.5> rotate z*5]
  [0.60
    bozo
    color_map {
        [0.0 color rgb <0.95,0.95,0.95>]
        [0.1 color rgb <0.9,0.9,0.9>]
        [0.5 color rgb <0.4, 0.4, 0.8>]
        [1.001 color rgb <0.04, 0.2, 0.66>]
    }
    turbulence 0.65
    octaves 6
    omega 0.707
    lambda 2
    scale <1.5, 0.6, 1.5> rotate z*10]
        }
    }

 rotate <90,0,0>
}

//background { color SkyBlue }

#declare Ramie = union
 {
 cylinder { <0,0,0>,<0,0,10>,0.2 }
 sphere { <0,0,0>,0.3 }
 }

#declare Palec = union
 {
 cylinder { <0,0,0>,<-1,0,-1>,0.17 }
 sphere { <-1,0,-1>,0.17 }
 cone { <-1,0,-1>,0.17,<0,0,-2>,0.1 }
 sphere { <0,0,-2>,0.1 }
 }

#declare RekaTexture=texture {Aluminum}

#declare Reka = union
 {
 object {Ramie}
 object {Palec rotate <0,30,0>}
 object {Palec rotate <0,30,180>}
 translate <0,0,2>
 texture {RekaTexture}
 scale 0.5
 }
#declare RekaTrzym = union
 {
 object {Ramie}
 object {Palec rotate <0,5,0>}
 object {Palec rotate <0,5,180>}
 translate <0,0,2>
 texture {RekaTexture}
 scale 0.5
 }


#declare BelkaPl = object
{
cylinder { <-0.4-DlugSegmPl/2,0,0>,<DlugSegmPl/2+0.4,0,0>,0.15
 texture { T_Wood17 scale 0.6 rotate <0,90,0> } }
}

#declare SlupekPl = union
{
box { <-0.2,-0.2,0>,<0.2,0.2,WysokPl> }
  union
  {
  triangle { <-0.2,-0.2,0>,<-0.2,0.2,0>,<0,0,0.2> }
  triangle { <-0.2, 0.2,0>,< 0.2,0.2,0>,<0,0,0.2> }
  triangle { < 0.2, 0.2,0>,< 0.2,-0.2,0>,<0,0,0.2> }
  triangle { < 0.2,-0.2,0>,<-0.2,-0.2,0>,<0,0,0.2> }
   translate WysokPl*z
  }
texture { T_Wood17 scale 0.8 } 
}

#declare SegmentPl = union
{
object { SlupekPl }
#declare N=IleBePl
#declare Y=WysokBePl
#declare R=seed(3333)
#while (N>0)
 #declare N=N-1
 object { BelkaPl rotate <360*rand(R),(rand(R)-0.5)*20*atan2(OdstepBePl,DlugSegmPl),0> translate <DlugSegmPl/2,0,Y> }
 #declare Y=Y+OdstepBePl
#end
}

#declare KolorDymu = color rgbf <0.7, 0.7, 0.6, 0>
//#declare KolorDymu = color rgbf <0.9, 0.9, 0.8, 0>

#declare DymTexture = texture
{
  pigment { bozo scale 0.3 }
  finish {ambient 1.0/GlobalAmbient diffuse 0}
}

#declare JedzonkoTexture = texture
{
pigment { marble
  color_map {
   [ 0 color White ]
   [ 0.1 color rgbf <1,1,0.3,0.6> ]
   [ 0.2 color rgbf <1,0.8,0,0.8> ]
   [ 0.6 color rgbf <1,0.5,0,0.95>]
            }
		turbulence 0.5
        }
	finish { ambient 1 }
}

#declare Asymil=0.25
#declare Szorst=0.25
#declare Wytrz=0.25
#declare Wchlan=0.25
#declare Stary=0
#declare Szybk=0.25
#declare Zniszcz=0

#declare MiesZgi=0
#declare Zgiecie=0

#declare MiesObr=0
#declare Obrot=0

#declare ReceptG=0
#declare ReceptT=0
#declare ReceptS=0
