// Tworzy definicje obiektow Stick i StickEnd na podstawie parametrow

#declare Stary1= 1.0-Stary

//#declare PodstRGB=(1-Wchlan)*StickRGB+Wchlan*WchlanRGB
#declare StickColor = color rgb (StickRGB*Stary1+StaryRGB*Stary)

#if (Zniszcz>0)
 #declare AsymColor = color rgbft<0,0,0,0,1>
 #declare Asymil=Zniszcz
#else
 #declare AsymColor = color rgb (AsymRGB*Stary1+StaryRGB*Stary)
#end

#declare MieColor1 = color rgb (Mie1RGB*Stary1+Stary2RGB*Stary)
#declare MieColor2 = color rgb (Mie2RGB*Stary1+Stary2RGB*Stary)
#declare MieColor3 = color rgb (Mie3RGB*Stary1+Stary2RGB*Stary)

#declare MiesTexture = texture
{
pigment
 {
 gradient x
 frequency 1
 turbulence 0.1
 ramp_wave
 color_map { [ 0 color MieColor1 ]
             [ 0.2 color MieColor2 ]
             [ 1 color MieColor3 ] }
 }
normal
  {
  radial
  scallop_wave
  frequency 6
  rotate <0,0,90>
  }

finish { phong Stary1*0.6 }
}

#declare Miesien = union
{
cylinder {<0,0,0>,<1,0,0>,0.1}
sphere {<0,0,0>,0.1}
texture {MiesTexture}
}

#declare Zmarszczki = normal
  {
  waves Stary*0.4
  frequency 10
  turbulence 0.2
  scallop_wave
  scale <0.1,0.8,0.1>
  rotate <10,40,30>
  }

#declare Chlorofil = pigment
  {
  gradient x
  frequency 2
  turbulence 2
  color_map
    {
     [0 color StickColor]
     [0.95-Asymil color StickColor]
     [1.05-Asymil color AsymColor]
    }
  triangle_wave
  }

#declare StickTexture = texture
{
pigment {Chlorofil}
#if (Stary)
normal { Zmarszczki }
#end
finish { phong Stary1*(1-Szorst) }
}

#declare StickEnd = union {
sphere { <0,0,0>,0.15
 texture
   {
#if (Stary<1)
   pigment { color StickColor }
#else
   pigment { Chlorofil scale 2 }
#end
	normal { bumps 1.5*Szorst*Stary1 scale 0.01 }
   finish { phong Stary1*(1-Szorst) }
   }
       }
#if (Wchlan > 0.05)
 #declare N=Wchlan*50*(1-Zniszcz)
 #declare R=seed(123)
 #while (N>0)
  #declare N=N-1
  sphere { <0,0,0.14> 0.03
	texture { 
		pigment { color rgb WchlanRGB*Stary1+StaryRGB*Stary }
		finish { phong Stary1 }
		}
	rotate <0,360*rand(R),360*rand(R)>
    }
 #end
#end
}

#declare Stick = union
{
#if (ReceptG)
#if (Zniszcz<0.9)
union {
 difference {
#end
#end
  cylinder { <0,0,0>,<1,0,0>,0.1 texture {StickTexture} }
#if (ReceptG)
#if (Zniszcz<0.9)
  cylinder { <0.38,0,0>,<0.62,0,0>,0.11 }
  }
 cylinder { <0.38,0,0>,<0.62,0,0>,0.11*(1-Zniszcz)
  texture
  {
   pigment { color rgbf <1.0, 1.0, 1.0, 0.9> }
   finish
   {
    ambient 0
    diffuse 0
    reflection 0.5
    refraction 1
    ior 1.4
    phong 0.3
    phong_size 60
   }
  }
         }
 sphere { <0.5,0,0>,(1-Zniszcz)*0.03
  texture { pigment { color rgb Stary*Stary2RGB+Stary1*<1,0,0> }
            finish { phong 1 } }
        }
 }
#end
#end
#if (ReceptS)
difference {
 cylinder { <0.75,0,0>,<0.85,0,0>,0.12 pigment { color rgb Stary*Stary2RGB+Stary1*<1,0.6,0> }}
#declare N=10
#while (N>0)
 #declare N=N-1
 sphere { <0.78,0.12,0>,0.019 pigment { color Gray10 } rotate x*N*36 }
 sphere { <0.82,0.12,0>,0.019 pigment { color Gray10 } rotate x*(18+N*36) }
#end
 }
#end
object { StickEnd translate <1,0,0>} 
#if (MiesZgi)
 #declare R=0.2
 #declare IleSegm=12

 #declare Kat=0
 #declare Wekt=<R,0,0>
 #declare Obwod=(pi+Zgiecie)*R
 #declare Dlug1=Obwod/IleSegm
 #declare Kat2=0
 #declare Wekt2=<R,0,0>
 #declare Obwod2=(pi-Zgiecie)*R
 #declare Dlug12=Obwod2/IleSegm

 #declare A=1+Zniszcz*IleSegm
 #while (A<IleSegm)
  #declare A=A+1
  #declare Kat=Kat+(pi+Zgiecie)/IleSegm
  #declare Kat2=Kat2+(pi-Zgiecie)/IleSegm

/*#warning concat("\nWekt=",str(Wekt.x,8,3),str(Wekt.y,8,3),str(Wekt.z,8,3))
#warning "\n"*/

#if (Zgiecie>-2.8)
  object
    { Miesien
    scale <Dlug1,Szybk,Szybk>
    rotate <0,0,270-degrees(Kat)>
    translate Wekt
    }
#end
#if (Zgiecie<2.8)
  object
    { Miesien
    scale <Dlug12,Szybk,Szybk>
    rotate <0,0,90+degrees(Kat2)>
    translate Wekt2
    }
#end

  #declare Wekt=Wekt+<-sin(Kat),-cos(Kat),0>*Dlug1
  #declare Wekt2=Wekt2+<-sin(Kat2),cos(Kat2),0>*Dlug12
 #end
#end
#if (Zniszcz<0.09)
#if (MiesObr)
 torus { 0.12, 0.1*Szybk*(1-Zniszcz)
texture
{
  pigment
   {
   radial
   frequency 25
   turbulence 0.1
   ramp_wave
    color_map { [ 0 color MieColor1 ]
             [ 0.2 color MieColor2 ]
             [ 1 color MieColor3 ] }
   }

   finish { phong Stary1*0.6 }
   } 
   rotate <0,0,90>
   translate <0.13,0,0>
  }
#end
#end

#if (ReceptT)
 #declare N=3*(1-Zniszcz)
 #while (N>0)
  #declare N=N-1
  union {
    cylinder { <1,0.1,0>,<1.15,0.12,0>,0.01 }
    sphere { <1.15,0.12,0>,0.01 }
    cone { <1.15,0.12,0>,0.01,<1.3,0.15,0>,0.007 }
    sphere { <1.3,0.15,0>,0.02 }
    texture { pigment { color rgb <0.1,0.1,0.1> } 
      finish { phong 1 } }
    rotate <45+120*N,0,0>
    }
 #end
#end

#if (Wytrz>0.05)
 #declare N=6*(1-Zniszcz)
 #while (N>0)
  #declare N=N-1
  cylinder 
   { <0,0,0.1>,<1,0,0.1>,Wytrz*0.04
   rotate <N*60,0,0>
   texture { pigment { color rgb WzmocRGB*Stary1+Stary2RGB*Stary } }
   normal { Zmarszczki }
	}
 #end
#end
}

